01背包及完全背包问题(51Nod

51Nod - 1085

题目:
在N件物品取出若干件放在容量为W的背包里,每件物品的体积为W1,W2……Wn(Wi为整数),与之相对应的价值为P1,P2……Pn(Pi为整数)。求背包能够容纳的最大价值。
Input
第1行,2个整数,N和W中间用空格隔开。N为物品的数量,W为背包的容量。(1 <= N <= 100,1 <= W <= 10000)
第2 - N + 1行,每行2个整数,Wi和Pi,分别是物品的体积和物品的价值。(1 <= Wi, Pi <= 10000)
Output
输出可以容纳的最大价值。
Sample Input

3 6
2 5
3 8
4 9

Sample Output

14

状态转移方程:
f[i][v]=max(f[i-1][v],f[i-1][v-w[i]]+p[i])
即放或不放第i件物品

首先是空间复杂度及时间复杂度都是O(NV)的写法

#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;

int w[105],p[105],f[105][10005];
int main()
{
    int N,V;
    cin>>N>>V;
    for(int i=1;i<=N;i++)
    {
        cin>>w[i]>>p[i];
    }
    memset(f,0,sizeof(f));
    for(int i=1;i<=N;i++)
        {
            for(int j=0;j<w[i];j++)
                f[i][j]=f[i-1][j];
            for(int j=w[i];j<=V;j++)
                f[i][j]=max(f[i-1][j],f[i-1][j-w[i]]+p[i]);
        }
    cout<<f[N][V]<<endl;
}

时间复杂度已经不能优化了,但是空间复杂度可以优化为O(V)。
使用放滚动数组f[v]来代替f[i][v],
f数组是从上到下,从右往左计算的。在计算f[i][j]之前,f[j]里保存的是f[i-1][j]的值,而f[j-w]里保存的是
f[i-1][j-w],因为j是逆序枚举的。(假如顺序枚举的话f[j-w]保存的会是f[i][j-w]的值)这样,f[j]=(max
[j],f[j-v]+w)实际上是把max{f[i-1][j],f[i-1][j-v]}保存在f[j]中,覆盖掉f[j]中原来的f[i-1][j].

#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;

int w[105],p[105],f[10005];
int main()
{
    int N,V;
    cin>>N>>V;
    for(int i=1;i<=N;i++)
    {
        cin>>w[i]>>p[i];
    }
    memset(f,0,sizeof(f));
    for(int i=1;i<=N;i++)
        {
            for(int j=V;j>=w[i];j--)
            {
                f[j]=max(f[j],f[j-w[i]]+p[i]);
            }
        }
    cout<< f[V]<< endl;
}

在紫书上还看到一种更简便的写法:

#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;

int w,p,f[10005];
int main()
{
    int N,V;
    cin>>N>>V;
    memset(f,0,sizeof(f));
    for(int i=1;i<=N;i++)
    {
        cin>>w>>p;
        for(int j=V;j>=w;j--)
            f[j]=max(f[j],f[j-w]+p);
    }
    cout<< f[V]<< endl;
}

其实就是边读入边计算,但自己完全想不到啊orz

HDU 1114 Piggy-Bank

Before ACM can do anything, a budget must be prepared and the necessary financial support obtained. The main income for this action comes from Irreversibly Bound Money (IBM). The idea behind is simple. Whenever some ACM member has any small money, he takes all the coins and throws them into a piggy-bank. You know that this process is irreversible, the coins cannot be removed without breaking the pig. After a sufficiently long time, there should be enough cash in the piggy-bank to pay everything that needs to be paid.

But there is a big problem with piggy-banks. It is not possible to determine how much money is inside. So we might break the pig into pieces only to find out that there is not enough money. Clearly, we want to avoid this unpleasant situation. The only possibility is to weigh the piggy-bank and try to guess how many coins are inside. Assume that we are able to determine the weight of the pig exactly and that we know the weights of all coins of a given currency. Then there is some minimum amount of money in the piggy-bank that we can guarantee. Your task is to find out this worst case and determine the minimum amount of cash inside the piggy-bank. We need your help. No more prematurely broken pigs!
Input
The input consists of T test cases. The number of them (T) is given on the first line of the input file. Each test case begins with a line containing two integers E and F. They indicate the weight of an empty pig and of the pig filled with coins. Both weights are given in grams. No pig will weigh more than 10 kg, that means 1 <= E <= F <= 10000. On the second line of each test case, there is an integer number N (1 <= N <= 500) that gives the number of various coins used in the given currency. Following this are exactly N lines, each specifying one coin type. These lines contain two integers each, Pand W (1 <= P <= 50000, 1 <= W <=10000). P is the value of the coin in monetary units, W is it’s weight in grams.
Output
Print exactly one line of output for each test case. The line must contain the sentence “The minimum amount of money in the piggy-bank is X.” where X is the minimum amount of money that can be achieved using coins with the given total weight. If the weight cannot be reached exactly, print a line “This is impossible.”.
Sample Input

3
10 110
2
1 1
30 50
10 110
2
1 1
50 30
1 6
2
10 3
20 4

Sample Output

The minimum amount of money in the piggy-bank is 60.
The minimum amount of money in the piggy-bank is 100.
This is impossible.

只需将01背包中v的循环倒过来就行,01背包中之所以逆序就是为了保证每件物品只放一件,而完全背包中不用考虑这个问题,这样而f[j-w]里保存的是f[i][j-w]而不是f[i-1][j-w],保证了物品可以多次取用。

#include <iostream>
#include <stdio.h>
#include <cstring>

using namespace std;
const int INF=0x3f3f3f3f;
int P,W,dp[10005];
int main()
{
    int T,E,F,N;
    cin>>T;
    while (T--)
    {
        cin>>E>>F>>N;
        int maxn=F-E;
        for(int i=0;i<=maxn;i++)
            dp[i]=INF;
        dp[0]=0;
        for(int i=0;i<N;i++)
        {
            cin>>P>>W;
            for(int j=W;j<=maxn;j++)
                if(dp[j-W]<INF)
                dp[j]=min(dp[j],dp[j-W]+P);
        }
        if(dp[maxn]>=INF)
            cout<<"This is impossible."<<endl;
        else
            cout<<"The minimum amount of money in the piggy-bank is "<<dp[maxn]<<'.'<<endl;
    }
    return 0;
}
原文地址:https://www.cnblogs.com/acagain/p/9180739.html